﻿using System;
using System.Threading.Tasks;
using CommonBehaviors.Actions;
using Styx;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using System.Diagnostics;
using Styx.Common;
using System.Windows.Media;
using Veven.spellManager;
using Veven.spellsAndAuras;
using Veven.units;

namespace Veven {
     class Veven : CombatRoutine {
        private static LocalPlayer Me {
            get { 
                return StyxWoW.Me;
            }
        }
        public override WoWClass Class {
            get {
                if (Me.Specialization == WoWSpec.WarriorArms || Me.Specialization == WoWSpec.WarriorFury)
                    return WoWClass.Warrior;
                else
                    return WoWClass.None;
            }
        }
        public override string Name {
            get {
                return "Veven - Arms/Fury Pve v1.4";
            }
        }
        public override void Initialize () {
            Logging.Write(Colors.OrangeRed, "Hello {0}!", Me.SafeName);
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.OrangeRed, "For optimal performance please use: Enyo");
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.OrangeRed, "-- Veven - Arms/Fury PvE --");
            Logging.Write(Colors.OrangeRed, "-- Version: v1.4 --");
            Logging.Write(Colors.OrangeRed, "-- by teamfe --");
            Logging.Write(Colors.OrangeRed, "-- A Arms/Fury PvE CombatRoutine --");
            //HotkeyManager.HotkeyManager.registerHotKeys();
        }
        public override void ShutDown () {
            //HotkeyManager.HotkeyManager.removeHotkeys();
        }
        public override Composite CombatBehavior {
            get {
                if (Me.Specialization == WoWSpec.WarriorArms)
                    return new ActionRunCoroutine(ctx => ArmsCoroutine());
                else
                    return new ActionRunCoroutine(ctx => FuryCoroutine());
            }
        }
        private static Stopwatch _enemyScanner = new Stopwatch();
        
        private static TimeSpan GetSpellCooldown (int spell) {
            SpellFindResults results;
            if (SpellManager.FindSpell(spell, out results)) {
                if (results.Override != null)
                    return results.Override.CooldownTimeLeft;
                return results.Original.CooldownTimeLeft;
            }
            return TimeSpan.MaxValue;
        }
        private static WoWUnit rendTarget;
        private static WoWUnit executeTarget;
        private static int enemyCount;
        private static int enemyRendCount;
        private static async Task<bool> ArmsCoroutine () {
            /*if (HotkeyManager.HotkeyManager.aoeOn) {
                if (await AsyncSpellManager.SpellCast(46924, false)) {
                    HotkeyManager.HotkeyManager.aoeOn = false;
                    return true;
                }
            }*/
            if (_enemyScanner.ElapsedMilliseconds >= 500) {
                rendTarget = null;
                rendTarget = Units.RendTarget();
                executeTarget = null;
                executeTarget = Units.ExecuteTarget();
                enemyCount = Units.SurroundingEnemiesInRange().Count;
                enemyRendCount = Units.SurroundingEnemiesWithRend().Count;
                _enemyScanner.Restart();
            } else if (_enemyScanner.IsRunning == false) {
                _enemyScanner.Start();
                Logging.WriteQuiet(String.Format("Starting EnemyScanner"));
            }
            if (enemyCount >= 2 && SpellManager.CanCast(SpellsAndAuras.sweepingStrikes)) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.sweepingStrikes, false)) {
                    return true;
                }
            }
            if (Me.IsCasting || SpellManager.GlobalCooldownLeft.Milliseconds >= 150) {
                return true;
            }
            if ((!Units.auraExists(Me.CurrentTarget, SpellsAndAuras.rend, true) || Units.auraTimeLeft(Me.CurrentTarget, SpellsAndAuras.rend, true) <= 4000) && SpellManager.CanCast(SpellsAndAuras.rend) && Me.CurrentRage >= 5 && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.rend)) {
                    rendTarget = null;
                    return true;
                }
            }
            if (executeTarget != null && SpellManager.CanCast(SpellsAndAuras.executeARMS) && executeTarget.IsWithinMeleeRangeOf(Me)) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.executeARMS, executeTarget)) {
                    executeTarget = null;
                    return true;
                }
            }
            if (enemyRendCount <= 4 && SpellManager.CanCast(SpellsAndAuras.rend) && Me.CurrentRage >= 5 && rendTarget != null && rendTarget.IsWithinMeleeRangeOf(Me)) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.rend, rendTarget)) {
                    rendTarget = null;
                    return true;
                }
            }
            if (!Me.CurrentTarget.HasAura(SpellsAndAuras.colossusSmash) && SpellManager.CanCast(SpellsAndAuras.colossusSmash) && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.colossusSmash)) {
                    return true;
                }
            }
            if (Me.CurrentTarget.HealthPercent > 20 && SpellManager.CanCast(SpellsAndAuras.mortalStrike) && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.mortalStrike)) {
                    return true;
                }
            }
            if (SpellManager.CanCast(SpellsAndAuras.executeARMS) && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.executeARMS)) {
                    return true;
                }
            }
            if (rendTarget != null && SpellManager.CanCast(SpellsAndAuras.rend) && rendTarget.IsWithinMeleeRangeOf(Me)) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.rend, rendTarget)) {
                    rendTarget = null;
                    return true;
                }
            }
            if (SpellManager.CanCast(SpellsAndAuras.colossusSmash) && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.colossusSmash)) {
                    return true;
                }
            }
            if (SpellManager.HasSpell(SpellsAndAuras.stormBolt) && !Me.CurrentTarget.HasAura(SpellsAndAuras.colossusSmash) && SpellManager.CanCast(SpellsAndAuras.stormBolt) && Me.CurrentTarget.IsTagged && Me.CurrentTarget.Distance <= 10) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.stormBolt)) {
                    return true;
                }
            }
            if (SpellManager.HasSpell(SpellsAndAuras.dragonRaor) && SpellManager.CanCast(SpellsAndAuras.dragonRaor) && Me.HasAura(SpellsAndAuras.bloodbath) && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.dragonRaor)) {
                    return true;
                }
            }
            if (Me.CurrentRage >= 61 && (Me.CurrentTarget.Distance <= 8 || Me.CurrentTarget.IsWithinMeleeRange) && SpellManager.CanCast(SpellsAndAuras.whirlwind)) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.whirlwind)) {
                    return true;
                }
            }
            if (SpellManager.CanCast(SpellsAndAuras.victoryRush) && Me.HasAura(SpellsAndAuras.victorious) && Me.CurrentTarget.IsWithinMeleeRange) {
                return await AsyncSpellManager.SpellCast(SpellsAndAuras.victoryRush);
            }
            return true;
        }
        private static async Task<bool> FuryCoroutine () {
            if (_enemyScanner.ElapsedMilliseconds >= 500) {
                executeTarget = null;
                executeTarget = Units.ExecuteTarget();
                _enemyScanner.Restart();
            } else if (_enemyScanner.IsRunning == false) {
                _enemyScanner.Start();
                Logging.WriteQuiet(String.Format("Starting EnemyScanner"));
            }
            if (SpellManager.CanCast(SpellsAndAuras.berserkerRage) && GetSpellCooldown(SpellsAndAuras.bloodthirst).TotalMilliseconds >= 3000 && Me.Auras["Raging Blow!"].StackCount < 2 && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.berserkerRage, false)) {
                    return true;
                }
            }
            if (Me.IsCasting || SpellManager.GlobalCooldownLeft.Milliseconds >= 150) {
                return true;
            }
            if (SpellManager.CanCast(SpellsAndAuras.wildStrike) && Me.CurrentRage > (Me.MaxRage - 20) && Me.CurrentTarget.HealthPercent > 20 && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.wildStrike)) {
                    return true;
                }
            }
            if (SpellManager.CanCast(SpellsAndAuras.bloodthirst) && (Me.CurrentRage < (Me.MaxRage - 40) || Me.HasAura(SpellsAndAuras.enrage) || Me.Auras["Raging Blow!"].StackCount < 2) && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.bloodthirst)) {
                    return true;
                }
            }
            if (executeTarget != null && SpellManager.CanCast(SpellsAndAuras.executeFURY) && executeTarget.IsWithinMeleeRangeOf(Me)) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.executeFURY, executeTarget)) {
                    executeTarget = null;
                    return true;
                }
            }
            if (SpellManager.CanCast(SpellsAndAuras.executeFURY) && Me.HasAura(SpellsAndAuras.suddenDeath) && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.executeFURY)) {
                    return true;
                }
            }
            if (SpellManager.CanCast(SpellsAndAuras.wildStrike) && !Me.HasAura(SpellsAndAuras.enrage) && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.wildStrike)) {
                    return true;
                }
            }
            if (SpellManager.CanCast(SpellsAndAuras.executeFURY) && Me.HasAura(SpellsAndAuras.suddenDeath) && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.executeFURY)) {
                    return true;
                }
            }
            if (SpellManager.CanCast(SpellsAndAuras.dragonRaor) && Me.HasAura(SpellsAndAuras.bloodbath) && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.dragonRaor)) {
                    return true;
                }
            }
            if (SpellManager.CanCast(SpellsAndAuras.ragingBlow) && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.ragingBlow)) {
                    return true;
                }
            }
            if (GetSpellCooldown(SpellsAndAuras.bloodthirst).TotalMilliseconds <= 500 && Me.CurrentRage < 50) {
                  return true;
            }
            if (SpellManager.CanCast(SpellsAndAuras.wildStrike) && Me.HasAura(SpellsAndAuras.enrage) && Me.CurrentTarget.HealthPercent > 20 && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.wildStrike)) {
                    return true;
                }
            }
            if(SpellManager.CanCast(SpellsAndAuras.bloodthirst) && Me.CurrentTarget.IsWithinMeleeRange) {
                if (await AsyncSpellManager.SpellCast(SpellsAndAuras.bloodthirst)) {
                    return true;
                }
            }
            return true;
        }
    }
}
